import matplotlib.pyplot as plt
import numpy as np


def readValuesForSolverEncoding(outputFile):
    x = [0]
    with open(fileName, 'r') as datafile:
        correctData = False
        for line in datafile.readlines():
            if line.startswith(outputFile):
                correctData = True
            elif line == "" or line == "\n":
                correctData = False
            elif correctData:
                #add twice to make horizontal lines in cactus plot
                x.append(float(line))
                x.append(float(line))
    x.append(1800) # last vertical line should long until end
    return x

if __name__ == '__main__':
    # input parameters
    fileName = "output_data_cactus.txt"
    usedLines = [".\output_data\output_treewidth1_Chuffed.txt",
                 ".\output_data\output_treewidth2_Chuffed.txt"]
    labels = ["SAT-B", "SAT-N"]
    imageName = "treewidth_cactus"

    plt.xticks(np.arange(0, 1801, step=200))

    for i in usedLines:
        x = readValuesForSolverEncoding(i)
        y = range(int(len(x)/2))
        # add twice to make vertical lines in cactus plot
        y = [item for item in y for i in range(2)]
        plt.plot(x, y)

    plt.xlabel("passed time")
    plt.ylabel("solved instances")
    plt.legend(labels)

    plt.savefig(imageName + ".png", bbox_inches='tight')
    plt.savefig(imageName + ".pdf", bbox_inches='tight')
    plt.show()
