import matplotlib.pyplot as plt
import numpy as np


def readValuesForSolverEncoding(outputFile):
    y = []
    linesSinceNew = 20
    with open(fileName, 'r') as datafile:
        for line in datafile.readlines():
            linesSinceNew += 1
            if linesSinceNew < 20:
                y.append(int(line))
            if line.startswith(outputFile):
                linesSinceNew = 0
    return y

if __name__ == '__main__':
    # input parameters
    fileName = "output_data_excel.txt"
    usedLines = [".\output_data\output_treewidth2_Chuffed.txt",
                 ".\output_data\output_treewidth2_COIN-BC.txt",
                 ".\output_data\output_treewidth2_Gecode.txt"]
    labels = ["Chuffed", "COIN-BC", "Gecode"]
    imageName = "treewidth2_solvers"

    plt.xticks(np.arange(2, 21, step=1))
    x = range(2, 21)
    y = []

    for i in usedLines:
        y = readValuesForSolverEncoding(i)
        if y == []:
            plt.plot([], y)
        else:
            plt.plot(x, y)

    plt.xlabel("number of vertices")
    plt.ylabel("solved instances")
    plt.legend(labels)

    plt.savefig(imageName + ".png", bbox_inches='tight')
    plt.savefig(imageName + ".pdf", bbox_inches='tight')
    plt.show()
