from optparse import OptionParser
import select
from sys import stderr, stdin, stdout
from os import isatty, listdir, getcwd
from os.path import join, basename, splitext
from glob import glob

out_path = '.\\twlib_graphs_dzn\\'
path = '.\\twlib_graphs_edge'

if __name__ == '__main__':
    for filename in glob(join(path, '*.dgf')):
        with open(join(getcwd(), filename), 'r') as inp:
            vertices = [0]
            verticesLabeledDifferent = False
            firstEdge = True
            smallGraph = False
            input = inp.readlines()
            for line in input:
                line = line.split()
                if line == []:
                    continue
                elif line[0] == 'p':
                    #small graph
                    if int(line[2]) < 100:
                        smallGraph = True
                        print(out_path + splitext(basename(filename))[0] + ".dzn")
                elif line[0] == 'n':
                    #labeling of nodes
                    verticesLabeledDifferent = True
                    vertices.append(int(line[1]))
                elif line[0] == 'e':
                    break
            if smallGraph:
                vertices.sort()
                with open(out_path + splitext(basename(filename))[0] + ".dzn", 'w') as out:
                    for line in input:
                        line = line.split()
                        if line == []:
                            continue
                        elif line[0] == 'p':
                            out.write("n = " + line[2] + ";\n")
                            out.write("m = " + line[3] + ";\n")
                            out.write("edges = [")
                        elif line[0] == 'e':
                            if not firstEdge:
                                out.write(", ")
                            if verticesLabeledDifferent:
                                out.write("{" + str(vertices.index(int(line[1]))) + ", " + str(vertices.index(int(line[2]))) + "}")
                            else:
                                out.write("{" + line[1] + ", " + line[2] + "}")
                            firstEdge = False
                    out.write("];")