from os.path import join, basename, splitext
from glob import glob

global beforeTimeout

# print summary of last graph size
def print_curr_statistics():
    out.write("\nnum of graphes: " + str(counter) + " out of " + str(numGraphsPerSize[graphSize]) + "\n")
    if counter != 0:
        out.write("individual times: " + ", ".join(map(str, individualTimes)) + "\n")
        out.write("finishing times: " + ", ".join(map(str, finishingTimes)) + "\n")
    if counter == numGraphsPerSize[graphSize]:
        out.write("average time: " + str(round(timeSum / counter, 2)) + "\n")
        excel.write(str(int(1800 / timeSum * counter)) + "\n")  # how many would have been solved, if number of graphs was unlimited
    else:
        out.write("did not finished all")
        excel.write(str(counter) + "\n")
    out.write("\n-----\n")


if __name__ == '__main__':
    # numGraphsPerSize[i] corresponds to graphSize i
    numGraphsPerSize = [0, 0, 4, 13, 25, 47, 29, 16, 17, 10, 9, 9, 12, 6, 9, 8, 25, 11, 7, 10, 8]
    with open("output_data_collection.txt", 'w') as out:
        # file for compact data for excel
        with open("output_data_excel.txt", 'w') as excel:
            # file for compact data for cactus plot
            with open("output_data_cactus.txt", 'w') as cactus:
                for filename in glob(join(".\\output_data\\", '*.txt')):
                    with open(filename, "r") as datafile:
                        out.write("\n" + filename + "\n")
                        excel.write("\n" + filename + "\n")
                        cactus.write("\n" + filename + "\n")
                        beforeTimeout = True
                        newGraph = False
                        graphSize = 0
                        overallTimeSum = 0
                        for line in datafile.readlines():
                            if line.startswith("##### "):
                                # Split and get size
                                graphName = splitext(basename(line))[0]
                                size = graphName[:2]
                                if graphSize != int(size):
                                    if graphSize != 0:
                                        print_curr_statistics()
                                    out.write("\ngraph size: " + size + "\n")
                                    graphSize = int(size)
                                    individualTimes = []
                                    finishingTimes = []
                                    counter = 0
                                    timeSum = 0
                                newGraph = True
                            # after the first timeout, no other instances are solved for the cactus graph
                            if line.startswith("timeout"):
                                beforeTimeout = False
                            if line.startswith("% time elapsed"):
                                if newGraph:
                                    counter = counter + 1
                                    line = line.split()
                                    individualTimes.append(line[3])
                                    timeSum = timeSum + float(line[3])
                                    finishingTimes.append(str(round(timeSum, 2)))
                                    overallTimeSum += float(line[3])
                                    if beforeTimeout and overallTimeSum <= 1800:
                                        cactus.write(str(round(overallTimeSum, 2)) + "\n")
                                    newGraph = False
                        print_curr_statistics()
